#ifndef __struct_access_h__
#define __struct_access_h__

typedef enum {
     pkt_type,
     len
} skbuff_types_u;

unsigned int GCC_NOREGPARM skbuff_get(void *p, skbuff_types_u t);
void GCC_NOREGPARM skbuff_set(void *p, skbuff_types_u t, unsigned long opt);

/** System time related stuff. */
long mytime(void);
/** System tyme without any offset */
long myrealtime(void);
/** System time in current timezone */
long mylocaltime(void);
void GCC_NOREGPARM mygetutime(int * tv);
void GCC_NOREGPARM mygetlongtime(unsigned long long * ptv);
unsigned long GCC_NOREGPARM myjiffies(void);
unsigned long GCC_NOREGPARM myhz(void);

/** Task queues. */
VN_TASKQUEUE mytq_immediate(void);
VN_TASKQUEUE mytq_timer(void);
VN_TQSTRUCT myalloc_tq_struct(void);
void GCC_NOREGPARM myfree_tq_struct(VN_TQSTRUCT tq);
int  GCC_NOREGPARM myfill_tq_struct(VN_TQSTRUCT tq, 
                         void GCC_NOREGPARM (*routine)(void *), 
                         void * arg );

/** Wait queue. */
VN_WAITQUEUE myalloc_waitqueue(void);
void GCC_NOREGPARM myfree_waitqueue(VN_WAITQUEUE wq);

/** sk_buff manupulation. */
/* Allocates memory for sk_buff atomically. */
VN_SKB GCC_NOREGPARM mydev_alloc_skb(unsigned int);
/* Allocates memory for sk_buff. Can sleep during allocation. */
VN_SKB GCC_NOREGPARM myalloc_skb(unsigned int size);
void GCC_NOREGPARM mydev_kfree_skb(VN_SKB);
void GCC_NOREGPARM mykfree_skb(VN_SKB skb);
unsigned char *	GCC_NOREGPARM myskb_put(VN_SKB skb, int len);
unsigned char *	GCC_NOREGPARM myskb_push(VN_SKB skb, int len);
VN_SKB GCC_NOREGPARM myskb_copy_expand(VN_SKB skb, unsigned int size, unsigned int frontOffset, unsigned int backOffset);
VN_SKB GCC_NOREGPARM myskb_create( unsigned int size, unsigned int frontOffset, unsigned int backOffset );
void GCC_NOREGPARM myskb_reserve(VN_SKB skb, unsigned int len);
int GCC_NOREGPARM myskb_expand_head(VN_SKB skb, int nhead, int ntail);
unsigned char* GCC_NOREGPARM myskb_pull(VN_SKB skb, unsigned int len);
int GCC_NOREGPARM myskb_trim(VN_SKB skb, unsigned int len);

/// @brief       
/// 
/// @param[in] skb    sk_buff
/// @param[in] offset  offset  ,   
///                    ,  

///      
void GCC_NOREGPARM myskb_move_mac_header(VN_SKB skbuff, int offset);

///      
void GCC_NOREGPARM myskb_move_headers(VN_SKB skb, int offset);

int GCC_NOREGPARM myskb_linearize(VN_SKB skb);
unsigned char GCC_NOREGPARM myskb_is_nonlinear(VN_SKB skb);
int GCC_NOREGPARM myskb_check_and_linearize( VN_SKB skb );
unsigned char ** GCC_NOREGPARM myskb_fetch_dev(VN_SKB skb);
void GCC_NOREGPARM myskb_set_dev(VN_SKB skb, VN_DEVICE dev);
unsigned char * GCC_NOREGPARM myskb_fetch_dst(VN_SKB skb);
struct neighbour * GCC_NOREGPARM mydst_fetch_neighbour(VN_SKB skb);
void GCC_NOREGPARM myneighbour_release(void *neigh);
int  GCC_NOREGPARM myneighbour_fetch_type(VN_NEIGHBOUR neighbour);
#ifdef CONFIG_IPLIR_XFRM_OUT
unsigned char * GCC_NOREGPARM myskb_fetch_cb(VN_SKB skb);
#else
unsigned int * GCC_NOREGPARM myskb_fetch_cb(VN_SKB skb);
#endif
unsigned char ** GCC_NOREGPARM myskb_fetch_tail(VN_SKB skb);
unsigned char ** GCC_NOREGPARM myskb_fetch_head(VN_SKB skb);
unsigned char ** GCC_NOREGPARM myskb_fetch_end(VN_SKB skb);
unsigned char ** GCC_NOREGPARM myskb_fetch_data(VN_SKB skb);
unsigned short GCC_NOREGPARM myskb_fetch_protocol(VN_SKB skb);
void GCC_NOREGPARM myskb_set_protocol(VN_SKB skb, unsigned short proto);
int GCC_NOREGPARM myis_ip_prtocol(VN_SKB skb);
unsigned char * GCC_NOREGPARM myskb_get_nh_raw(VN_SKB skb);
unsigned char * GCC_NOREGPARM myskb_get_h_raw(VN_SKB skb);
unsigned char * GCC_NOREGPARM myskb_get_mac_raw(VN_SKB skb);
unsigned char * GCC_NOREGPARM myskb_get_inner_mac_raw(VN_SKB skb);
unsigned char ** GCC_NOREGPARM myskb_fetch_list(VN_SKB skb);
unsigned char ** GCC_NOREGPARM myskb_fetch_sk(VN_SKB skb);
unsigned char GCC_NOREGPARM myskb_fetch_ip_summed(VN_SKB skb);
void GCC_NOREGPARM myskb_set_ip_summed(VN_SKB skb, unsigned char ip_summed);
unsigned char * GCC_NOREGPARM myskb_fetch_pkt_type(VN_SKB skb);
unsigned int * GCC_NOREGPARM myskb_fetch_len(VN_SKB skb);
unsigned int * GCC_NOREGPARM myskb_fetch_data_len(VN_SKB skb);
unsigned int * GCC_NOREGPARM myskb_fetch_csum(VN_SKB skb);
/// @brief - Return network header from start of buffer
///
/// @param skb - struct sk_buff*
int GCC_NOREGPARM myskb_network_offset(VN_SKB skb);
/// @brief - Check that a socket buffer's data buffers are writable
///
/// @skb - The socket buffer to check
/// @tailbits - Amount of trailing space to be added
/// @trailer - Returned pointer to the skb where the tailbits space begins
int GCC_NOREGPARM myskb_cow_data(VN_SKB skb, int tailbits, VN_SKB *trailer);

/// @brief - Return pointer to the end of buffer
///
/// @param skb : struct sk_buff*
unsigned char * GCC_NOREGPARM myskb_tail_pointer(VN_SKB skb);
/// @brief - Add data to the tail of a potentially fragmented buffer
///
/// @skb - start of the buffer to use
/// @tail - tail fragment of the buffer to use
/// @len - amount of data to add
/// @return - a pointer to the first byte of the extra data
unsigned char * GCC_NOREGPARM mypskb_put(VN_SKB skb, VN_SKB tail, int len);
/// @brief Copy the specified number of bytes at the specified offset of the given SKB into the 'to' buffer.
///
/// @param skb - struct sk_buff*
/// @param offset - start offset from which to copy data
/// @param to - destination buffer
/// @len - amount of data to copy
int GCC_NOREGPARM myskb_copy_bits(VN_SKB skb, int offset, void *to, int len);
/// @brief Expand head and/or tail rooms of sk_buff
///
/// @param skb - struct sk_buff*
/// @return 0 - no expansion needed, otherwise result of expansion
int GCC_NOREGPARM my_skb_check_space(VN_SKB skb);
/// @brief Set mac immediately before network header
///
/// @param skb - struct sk_buff*
void GCC_NOREGPARM my_skb_mac_header_rebuild(VN_SKB skb);

/// \brief ,        (L3,L4).
///
///   ,        .
///         .
/// 
/// \param[in] skb    sk_buff
void GCC_NOREGPARM myskb_calc_csum(VN_SKB skb);

/// \brief       UDP  .  IPv6 
///
/// \param[in] skb    sk_buff
/// \param[in] partial  
void GCC_NOREGPARM myskb_calc_udp_csum_v6(VN_SKB skb, int partial);

/// \brief  UDP    IPv6    IPv6 payload
///
/// \param[in] skb    sk_buff
/// \param[in] sport_be, dport_be  UPD  big-endian 
/// \param[in] touchh  layer-2  
unsigned char * GCC_NOREGPARM myskb_insert_udp_hdr_v6(VN_SKB skbuff, unsigned short sport_be, unsigned short dport_be, int touchh);

/// \brief  UDP   IPv6 
///
/// \param[in] partial  
void GCC_NOREGPARM myskb_remove_udp_hdr_v6(VN_SKB skbuff);

/// \brief ,         (L3,L4).
///
///   ,         .
///         .
/// 
/// \param[in] skb    sk_buff
void GCC_NOREGPARM myskb_clear_csum(VN_SKB skbuff);

/// @brief       (L3,L4)   .
///
/// @param skb    sk_buff
/// @return 1 -         ,    
///         0 -            
int GCC_NOREGPARM myskb_need_csum_receive(VN_SKB skbuff);

/// @brief ,     (L3,L4)   .
/// 
/// @param skb    sk_buff
/// @return 1 -     ; 0 -  
int GCC_NOREGPARM myskb_need_csum_transmit(VN_SKB skbuff);

/// \brief  ,   (L3,L4)  .
///
///    ,     .
///         .
/// 
/// \param[in] skb    sk_buff
void GCC_NOREGPARM myskb_ok_csum(VN_SKB skbuff);

/// @brief ,      MTU   .
///
/// @param skb    sk_buff
/// @return 1 -    MTU; 0 -  
int GCC_NOREGPARM myskb_size_overhead_mtu(VN_SKB skbuff);

/// \brief     .
///
///           
///  .
///
/// \param[in] skb    sk_buff
void GCC_NOREGPARM myskb_set_network_header(VN_SKB skbuff, int offset);

/// @brief    secpath-      
///
/// @param skb    sk_buff
/// @return 0 -   ; 1 -      
int GCC_NOREGPARM myskb_create_secpath(VN_SKB skbuff);

/// @brief    4 bytes long storage  secpath ,     
///
/// @param skb    sk_buff
/// @return NULL -    ;    -   storage
void * GCC_NOREGPARM myskb_get_secpath_iplir_storage(VN_SKB skbuff);

/// @brief ,    IPSec-.
///
/// @param skb    sk_buff
/// @return 1 - , 0 - 
int GCC_NOREGPARM myskb_is_orig_secpath_exist(VN_SKB skbuff);

/// \brief     .
///
///           
///  .
///
/// \param[in] skb    sk_buff
void GCC_NOREGPARM myskb_set_transport_header(VN_SKB skbuff, int offset);
#if 0
unsigned char ** GCC_NOREGPARM myskb_fetch_physindev(VN_SKB);
unsigned char ** GCC_NOREGPARM myskb_fetch_physoutdev(VN_SKB);
#endif
void GCC_NOREGPARM myskb_clear_dst(VN_SKB skbuff);
/** net_device manupulation. */
unsigned short * GCC_NOREGPARM mydev_fetch_type(VN_DEVICE dev);
unsigned int    GCC_NOREGPARM mydev_fetch_flags(VN_DEVICE dev);
unsigned char * GCC_NOREGPARM mydev_fetch_name(VN_DEVICE dev);
unsigned short GCC_NOREGPARM mydev_fetch_header_len( VN_DEVICE dev );
unsigned * GCC_NOREGPARM mydev_fetch_mtu(VN_DEVICE dev);
unsigned char ** GCC_NOREGPARM mydev_fetch_ip_ptr(VN_DEVICE dev);
unsigned char * GCC_NOREGPARM mydev_fetch_dev_addr(VN_DEVICE dev);
unsigned char ** GCC_NOREGPARM mynf_info_fetch_outdev(VN_NFINFO nfinfo);
unsigned char ** GCC_NOREGPARM mynf_info_fetch_indev(VN_NFINFO nfinfo);

/** Interface structures. */
unsigned char ** GCC_NOREGPARM myin_dev_fetch_ifa_list(VN_INDEVICE indev);
unsigned char ** GCC_NOREGPARM myin_ifaddr_fetch_ifa_next(VN_INIFADDR ifa);
unsigned char * GCC_NOREGPARM myin_ifaddr_fetch_ifa_label(VN_INIFADDR ifa);
unsigned int * GCC_NOREGPARM myin_ifaddr_fetch_ifa_local(VN_INIFADDR ifa);
unsigned int GCC_NOREGPARM myin_ifaddr_fetch_ifa_broadcast( VN_INIFADDR ifa );
VN_DEVICE GCC_NOREGPARM myin_ifaddr_fetch_netdev(VN_INIFADDR ifa);

/** Neighbour and it's contants. */
unsigned char * GCC_NOREGPARM myneighbour_fetch_nud_state(VN_NEIGHBOUR neigh);
int myNUD_INCOMPLETE(void);
int myNUD_NOARP(void);
int myNUD_FAILED(void);
int myNUD_REACHABLE(void);
VN_NEIGHTABLE myarp_tbl(void);

/** PCI device. */
unsigned int * GCC_NOREGPARM mypci_dev_fetch_irq(VN_PCIDEV dev);

/** File operations. */
VN_FILEOPERATIONS myalloc_fops(void);
void GCC_NOREGPARM myfree_fops(VN_FILEOPERATIONS fop);
void GCC_NOREGPARM myfill_fops(VN_FILEOPERATIONS, void *, void *,
                               void *, void *);

/** Timer structures. */
VN_TIMER myget_timer(void);
void GCC_NOREGPARM myfree_timer(VN_TIMER timer);
void GCC_NOREGPARM myset_timer(VN_TIMER timer, int seconds, void* data,
                 void GCC_NOREGPARM (* function)(void*));
int GCC_NOREGPARM mymod_timer(VN_TIMER timer, int secondtenths );


/** Mutex. */
VN_MUTEX mymutex_alloc(void);
void GCC_NOREGPARM mymutex_free(VN_MUTEX);
VN_MUTEX mymutex_alloc_locked(void);

/** Spinlock. */
VN_SPINLOCK myspinlock_alloc(void);
void GCC_NOREGPARM myspinlock_free(VN_SPINLOCK);

/** rwlock. */
VN_RWLOCK myrwlock_alloc(void);
void GCC_NOREGPARM myrwlock_free(VN_RWLOCK);
void GCC_NOREGPARM mydown_read(VN_RWLOCK);
void GCC_NOREGPARM myup_read(VN_RWLOCK);
void GCC_NOREGPARM mydown_write(VN_RWLOCK);
void GCC_NOREGPARM myup_write(VN_RWLOCK);

VN_KMEM_CACHE GCC_NOREGPARM mykmem_cache_create(const char *name, int size, int offset);
void GCC_NOREGPARM mykmem_cache_destroy( VN_KMEM_CACHE );
int GCC_NOREGPARM mykmem_cache_shrink( VN_KMEM_CACHE );
void* GCC_NOREGPARM mykmem_cache_alloc_atomic( VN_KMEM_CACHE );
void* GCC_NOREGPARM mykmem_cache_alloc_kernel( VN_KMEM_CACHE );
void GCC_NOREGPARM mykmem_cache_free( VN_KMEM_CACHE, void *);
#ifdef SLAB_LEAK_TEST
void mykmem_print_stats();
#endif

int GCC_NOREGPARM mytask_get_pid( VN_TASK_STRUCT tsk );

/** Various constants. */
int myPAGE_SIZE(void);
int myENODEV(void);
/// \brief     .
///
///         EINVAL
/// 
/// \return    EINVAL.
int myEINVAL(void);
/// \brief     .
///
///         EFAULT
/// 
/// \return    EFAULT.
int myEFAULT(void);
int myARPOP_REQUEST(void);
int myETH_P_IP(void);
int myETH_P_ARP(void);
int myETH_P_IPV6(void);
int myARPHRD_ETHER(void);
int myARPHRD_PPP(void);
int myARPHRD_SLIP(void);
int myARPHRD_CSLIP(void);
int myARPHRD_SLIP6(void);
int myARPHRD_CSLIP6(void);
int myARPHRD_SIT(void);
int myETH_HLEN(void);
int myETH_ALEN(void);
int myIFF_LOOPBACK(void);
int myCHECKSUM_UNNECESSARY(void);
int myCHECKSUM_NONE(void);
int myCHECKSUM_COMPLETE(void);
int myPACKET_HOST(void);
int myPACKET_BROADCAST(void);
int myPACKET_LOOPBACK(void);
int myRTN_BROADCAST(void);
int GCC_NOREGPARM IsSupportedOtherMediumType( int medium );

int myERESTARTSYS(void);

unsigned long long GCC_NOREGPARM __udivdi3(unsigned long long a, unsigned long b);
unsigned long GCC_NOREGPARM __umoddi3(unsigned long long a, unsigned long b);

void mytimer_handler(void *arg);

int GCC_NOREGPARM myis_arp_protocol( VN_SKB skbuff );

#endif /* __struct_access_h__ */
